diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py ns-3.36/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:58.114734600 -0700
@@ -4270,7 +4274,7 @@
                    'uint8_t', 
                    [param('uint8_t', 'ipTos')], 
                    is_static=True)
-    ## socket.h (module 'network'): void ns3::Socket::Ipv6JoinGroup(ns3::Ipv6Address address, ns3::Socket::Ipv6MulticastFilterMode filterMode, std::vector<ns3::Ipv6Address, std::allocator<ns3::Ipv6Address> > sourceAddresses) [member function]
+    ## socket.h (module 'network'): void ns3::Socket::Ipv6JoinGroup(ns3::Ipv6Address address, ns3::Socket::Ipv6MulticastFilterMode filterMode, std::vector<ns3::Ipv6Address, std::allocator<ns3::Ipv6Address>> sourceAddresses) [member function]
     cls.add_method('Ipv6JoinGroup', 
                    'void', 
                    [param('ns3::Ipv6Address', 'address'), param('ns3::Socket::Ipv6MulticastFilterMode', 'filterMode'), param('std::vector< ns3::Ipv6Address >', 'sourceAddresses')], 
@@ -5857,7 +5861,7 @@
                    'ns3::Ipv4Address', 
                    [], 
                    is_const=True)
-    ## ipv4-route.h (module 'internet'): std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, unsigned int> > > ns3::Ipv4MulticastRoute::GetOutputTtlMap() const [member function]
+    ## ipv4-route.h (module 'internet'): std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, unsigned int>>> ns3::Ipv4MulticastRoute::GetOutputTtlMap() const [member function]
     cls.add_method('GetOutputTtlMap', 
                    'std::map< unsigned int, unsigned int >', 
                    [], 
@@ -6681,7 +6685,7 @@
                    'ns3::Ipv6Address', 
                    [], 
                    is_const=True)
-    ## ipv6-route.h (module 'internet'): std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, unsigned int> > > ns3::Ipv6MulticastRoute::GetOutputTtlMap() const [member function]
+    ## ipv6-route.h (module 'internet'): std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, unsigned int>>> ns3::Ipv6MulticastRoute::GetOutputTtlMap() const [member function]
     cls.add_method('GetOutputTtlMap', 
                    'std::map< unsigned int, unsigned int >', 
                    [], 
@@ -7093,10 +7097,16 @@
     cls.add_method('ExtractNeighborIndex', 
                    'uint32_t', 
                    [param('uint32_t', 'numberOfBits')])
-    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() [member function]
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetEpoch() const [member function]
+    cls.add_method('GetEpoch', 
+                   'uint32_t', 
+                   [], 
+                   is_const=True)
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() const [member function]
     cls.add_method('GetRemainingBits', 
                    'uint32_t', 
-                   [])
+                   [], 
+                   is_const=True)
     ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetSerializedSize() const [member function]
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
@@ -7107,6 +7117,10 @@
                    'uint32_t', 
                    [param('uint32_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
+    ## nix-vector.h (module 'network'): void ns3::NixVector::SetEpoch(uint32_t epoch) [member function]
+    cls.add_method('SetEpoch', 
+                   'void', 
+                   [param('uint32_t', 'epoch')])
     return
 
 def register_Ns3Node_methods(root_module, cls):
@@ -7438,10 +7452,11 @@
                    'uint32_t', 
                    [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
-    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) [member function]
+    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) const [member function]
     cls.add_method('SetNixVector', 
                    'void', 
-                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')])
+                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')], 
+                   is_const=True)
     ## packet.h (module 'network'): std::string ns3::Packet::ToString() const [member function]
     cls.add_method('ToString', 
                    'std::string', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/CMakeLists.txt ns-3.36/src/nix-vector-routing/CMakeLists.txt
--- ns-3.35/src/nix-vector-routing/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/nix-vector-routing/CMakeLists.txt	2022-04-30 18:23:58.114734600 -0700
@@ -0,0 +1,11 @@
+build_lib(
+  LIBNAME nix-vector-routing
+  SOURCE_FILES helper/nix-vector-helper.cc
+               model/nix-vector-routing.cc
+  HEADER_FILES helper/nix-vector-helper.h
+               model/nix-vector-routing.h
+  DEPRECATED_HEADER_FILES helper/ipv4-nix-vector-helper.h
+                          model/ipv4-nix-vector-routing.h
+  LIBRARIES_TO_LINK ${libinternet}
+  TEST_SOURCES test/nix-test.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/examples/CMakeLists.txt ns-3.36/src/nix-vector-routing/examples/CMakeLists.txt
--- ns-3.35/src/nix-vector-routing/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/nix-vector-routing/examples/CMakeLists.txt	2022-04-30 18:23:58.114734600 -0700
@@ -0,0 +1,31 @@
+set(base_examples
+    nix-simple
+    nix-simple-multi-address
+    nms-p2p-nix
+)
+
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK
+      ${libpoint-to-point}
+      ${libinternet}
+      ${libapplications}
+      ${libnix-vector-routing}
+  )
+endforeach()
+
+build_lib_example(
+  NAME nix-double-wifi
+  SOURCE_FILES nix-double-wifi.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libwifi}
+    ${libapplications}
+    ${libinternet}
+    ${libnix-vector-routing}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/examples/nix-double-wifi.cc ns-3.36/src/nix-vector-routing/examples/nix-double-wifi.cc
--- ns-3.35/src/nix-vector-routing/examples/nix-double-wifi.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/examples/nix-double-wifi.cc	2022-04-30 18:23:58.114734600 -0700
@@ -65,7 +65,7 @@
  * IPv4:
  * \verbatim
    Time: +7s, Nix Routing
-   Route Path: (Node 4 to Node 7, Nix Vector: 100011)
+   Route path from Node 4 to Node 7, Nix Vector: 100011 (6 bits left)
    10.1.1.3                 (Node 4)  ---->   10.1.1.4                 (Node 0)
    10.1.2.1                 (Node 0)  ---->   10.1.2.2                 (Node 1)
    10.1.3.4                 (Node 1)  ---->   10.1.3.3                 (Node 7)
@@ -74,7 +74,7 @@
  * IPv6:
  * \verbatim
    Time: +7s, Nix Routing
-   Route Path: (Node 4 to Node 7, Nix Vector: 100011)
+   Route path from Node 4 to Node 7, Nix Vector: 100011 (6 bits left)
    2001:1::200:ff:fe00:5    (Node 4)  ---->   fe80::200:ff:fe00:6      (Node 0)
    fe80::200:ff:fe00:1      (Node 0)  ---->   fe80::200:ff:fe00:2      (Node 1)
    fe80::200:ff:fe00:a      (Node 1)  ---->   2001:3::200:ff:fe00:9    (Node 7)
@@ -126,7 +126,6 @@
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
-  wifi.SetRemoteStationManager ("ns3::AarfWifiManager");
 
   WifiMacHelper mac;
   Ssid ssid = Ssid ("ns-3-ssid-first");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/examples/nix-simple.cc ns-3.36/src/nix-vector-routing/examples/nix-simple.cc
--- ns-3.35/src/nix-vector-routing/examples/nix-simple.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/examples/nix-simple.cc	2022-04-30 18:23:58.114734600 -0700
@@ -78,114 +78,104 @@
  * - Source (n1) and Destination (n1)
  *   It goes from n1 -> n1
  * .
+ * 
+ * Expected IPv4 Routing Path output for above
+ * cases (in the output stream):
  * \verbatim
-   Expected IPv4 Routing Path output for above
-   cases (in the output stream):
-   Time: +3s, Nix Routing
-   Route Path: (Node 0 to Node 3, Nix Vector: 101)
-   10.1.4.1 (Node 0)   ---->   10.1.4.2 (Node 2)
-   10.1.3.1 (Node 2)   ---->   10.1.3.2 (Node 3)
-
-   Time: +5s, Nix Routing
-   Route Path: (Node 1 to Node 3, Nix Vector: 101)
-   10.1.2.1 (Node 1)   ---->   10.1.2.2 (Node 2)
-   10.1.3.1 (Node 2)   ---->   10.1.3.2 (Node 3)
-
-   Time: +6s, Nix Routing
-   Route Path: (Node 2 to Node 0, Nix Vector: 10)
-   10.1.4.2 (Node 2)   ---->   10.1.4.1 (Node 0)
-
-   Time: +7s, Nix Routing
-   Route Path: (Node 1 to Node 1, Nix Vector: )
-   10.1.1.2 (Node 1)   ---->   10.1.1.2 (Node 1)
-
-   Node: 0, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination     NixVector
-   10.1.3.2        101
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.3.2        10.1.4.2        10.1.4.1          2
-
-   Node: 1, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination     NixVector
-   10.1.3.2        101
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.3.2        10.1.2.2        10.1.2.1          2
-
-   Node: 2, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination     NixVector
-   10.1.1.1        10
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.1.1        10.1.4.1        10.1.4.2          3
-   10.1.3.2        10.1.3.2        10.1.3.1          2
-   10.1.4.1        10.1.4.1        10.1.4.2          3
-
-   Node: 3, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination     NixVector
-   10.1.4.1        010
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.4.1        10.1.3.1        10.1.3.2          1
+  Time: +3s, Nix Routing
+  Route path from Node 0 to Node 3, Nix Vector: 101 (3 bits left)
+  10.1.4.1                 (Node 0)  ---->   10.1.4.2                 (Node 2)
+  10.1.3.1                 (Node 2)  ---->   10.1.3.2                 (Node 3)
+
+  Time: +5s, Nix Routing
+  Route path from Node 1 to Node 3, Nix Vector: 101 (3 bits left)
+  10.1.2.1                 (Node 1)  ---->   10.1.2.2                 (Node 2)
+  10.1.3.1                 (Node 2)  ---->   10.1.3.2                 (Node 3)
+
+  Time: +6s, Nix Routing
+  Route path from Node 2 to Node 0, Nix Vector: 10 (2 bits left)
+  10.1.4.2                 (Node 2)  ---->   10.1.1.1                 (Node 0)
+
+  Time: +7s, Nix Routing
+  Route path from Node 1 to Node 1, Nix Vector: 
+  10.1.1.2                 (Node 1)  ---->   10.1.1.2                 (Node 1)
+
+  Node: 0, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  Destination                   NixVector
+  10.1.3.2                      101 (3 bits left)
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  10.1.3.2                      10.1.4.2                      10.1.4.1                        1
+
+  Node: 1, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  IpRouteCache:
+
+  Node: 2, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  10.1.3.2                      10.1.3.2                      10.1.3.1                        1
+  10.1.4.1                      10.1.4.1                      10.1.4.2                        2
+
+  Node: 3, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  Destination                   NixVector
+  10.1.4.1                      010 (3 bits left)
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  10.1.4.1                      10.1.3.1                      10.1.3.2                        0
    \endverbatim
  *
+ * Expected IPv6 Routing Path output for above
+ * cases (in the output stream):
  * \verbatim
-   Expected IPv6 Routing Path output for above
-   cases (in the output stream):
-   Time: +3s, Nix Routing
-   Route Path: (Node 0 to Node 3, Nix Vector: 101)
-   2001:4::200:ff:fe00:7    (Node 0)  ---->   fe80::200:ff:fe00:8      (Node 2)
-   fe80::200:ff:fe00:5      (Node 2)  ---->   2001:3::200:ff:fe00:6    (Node 3)
-
-   Time: +5s, Nix Routing
-   Route Path: (Node 1 to Node 3, Nix Vector: 101)
-   2001:2::200:ff:fe00:3    (Node 1)  ---->   fe80::200:ff:fe00:4      (Node 2)
-   fe80::200:ff:fe00:5      (Node 2)  ---->   2001:3::200:ff:fe00:6    (Node 3)
-
-   Time: +6s, Nix Routing
-   Route Path: (Node 2 to Node 0, Nix Vector: 10)
-   2001:4::200:ff:fe00:8    (Node 2)  ---->   2001:1::200:ff:fe00:1    (Node 0)
-
-   Time: +7s, Nix Routing
-   Route Path: (Node 1 to Node 1, Nix Vector: )
-   2001:1::200:ff:fe00:2    (Node 1)  ---->   2001:1::200:ff:fe00:2    (Node 1)
-
-   Node: 0, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination                   NixVector
-   2001:3::200:ff:fe00:6         101
-   IpRouteCache:
-   Destination                   Gateway                       Source                        OutputDevice
-   2001:3::200:ff:fe00:6         fe80::200:ff:fe00:8           2001:4::200:ff:fe00:7           1
-
-   Node: 1, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination                   NixVector
-   2001:3::200:ff:fe00:6         101
-   IpRouteCache:
-
-   Node: 2, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination                   NixVector
-   2001:1::200:ff:fe00:1         10
-   IpRouteCache:
-   Destination                   Gateway                       Source                        OutputDevice
-   2001:3::200:ff:fe00:6         fe80::200:ff:fe00:6           fe80::200:ff:fe00:5             1
-   2001:4::200:ff:fe00:7         fe80::200:ff:fe00:7           fe80::200:ff:fe00:8             2
-
-   Node: 3, Time: +8s, Local time: +8s, Nix Routing
-   NixCache:
-   Destination                   NixVector
-   2001:4::200:ff:fe00:7         010
-   IpRouteCache:
-   Destination                   Gateway                       Source                        OutputDevice
-   2001:4::200:ff:fe00:7         fe80::200:ff:fe00:5           2001:3::200:ff:fe00:6           0
-   \endverbatim
+  Time: +3s, Nix Routing
+  Route path from Node 0 to Node 3, Nix Vector: 101 (3 bits left)
+  2001:4::200:ff:fe00:7    (Node 0)  ---->   fe80::200:ff:fe00:8      (Node 2)
+  fe80::200:ff:fe00:5      (Node 2)  ---->   2001:3::200:ff:fe00:6    (Node 3)
+
+  Time: +5s, Nix Routing
+  Route path from Node 1 to Node 3, Nix Vector: 101 (3 bits left)
+  2001:2::200:ff:fe00:3    (Node 1)  ---->   fe80::200:ff:fe00:4      (Node 2)
+  fe80::200:ff:fe00:5      (Node 2)  ---->   2001:3::200:ff:fe00:6    (Node 3)
+
+  Time: +6s, Nix Routing
+  Route path from Node 2 to Node 0, Nix Vector: 10 (2 bits left)
+  2001:4::200:ff:fe00:8    (Node 2)  ---->   2001:1::200:ff:fe00:1    (Node 0)
+
+  Time: +7s, Nix Routing
+  Route path from Node 1 to Node 1, Nix Vector: 
+  2001:1::200:ff:fe00:2    (Node 1)  ---->   2001:1::200:ff:fe00:2    (Node 1)
+
+  Node: 0, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  Destination                   NixVector
+  2001:3::200:ff:fe00:6         101 (3 bits left)
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  2001:3::200:ff:fe00:6         fe80::200:ff:fe00:8           2001:4::200:ff:fe00:7           1
+
+  Node: 1, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  IpRouteCache:
+
+  Node: 2, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  2001:3::200:ff:fe00:6         fe80::200:ff:fe00:6           fe80::200:ff:fe00:5             1
+  2001:4::200:ff:fe00:7         fe80::200:ff:fe00:7           fe80::200:ff:fe00:8             2
+
+  Node: 3, Time: +8s, Local time: +8s, Nix Routing
+  NixCache:
+  Destination                   NixVector
+  2001:4::200:ff:fe00:7         010 (3 bits left)
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  2001:4::200:ff:fe00:7         fe80::200:ff:fe00:5           2001:3::200:ff:fe00:6           0
+  \endverbatim
  */
 
 using namespace ns3;
@@ -204,35 +194,21 @@
   LogComponentEnable ("UdpEchoClientApplication", LOG_LEVEL_INFO);
   LogComponentEnable ("UdpEchoServerApplication", LOG_LEVEL_INFO);
 
-  NodeContainer nodes12;
-  nodes12.Create (2);
-
-  NodeContainer nodes23;
-  nodes23.Add (nodes12.Get (1));
-  nodes23.Create (1);
-
-  NodeContainer nodes34;
-  nodes34.Add (nodes23.Get (1));
-  nodes34.Create (1);
-
-  NodeContainer nodes13;
-  nodes13.Add (nodes12.Get (0));
-  nodes13.Add (nodes34.Get (0));
+  NodeContainer nodes;
+  nodes.Create (4);
 
   PointToPointHelper pointToPoint;
   pointToPoint.SetDeviceAttribute ("DataRate", StringValue ("5Mbps"));
   pointToPoint.SetChannelAttribute ("Delay", StringValue ("2ms"));
 
-  NodeContainer allNodes = NodeContainer (nodes12, nodes23.Get (1), nodes34.Get (1));
-
+  NetDeviceContainer devices01;
   NetDeviceContainer devices12;
   NetDeviceContainer devices23;
-  NetDeviceContainer devices34;
-  NetDeviceContainer devices13;
-  devices12 = pointToPoint.Install (nodes12);
-  devices23 = pointToPoint.Install (nodes23);
-  devices34 = pointToPoint.Install (nodes34);
-  devices13 = pointToPoint.Install (nodes13);
+  NetDeviceContainer devices02;
+  devices01 = pointToPoint.Install (NodeContainer (nodes.Get (0), nodes.Get (1)));
+  devices12 = pointToPoint.Install (NodeContainer (nodes.Get (1), nodes.Get (2)));
+  devices23 = pointToPoint.Install (NodeContainer (nodes.Get (2), nodes.Get (3)));
+  devices02 = pointToPoint.Install (NodeContainer (nodes.Get (0), nodes.Get (2)));
 
   Address udpServerAddress;
 
@@ -243,7 +219,7 @@
       Ipv4NixVectorHelper nixRouting;
       InternetStackHelper stack;
       stack.SetRoutingHelper (nixRouting); // has effect on the next Install ()
-      stack.Install (allNodes);
+      stack.Install (nodes);
 
       Ipv4AddressHelper address1;
       address1.SetBase ("10.1.1.0", "255.255.255.0");
@@ -254,19 +230,19 @@
       Ipv4AddressHelper address4;
       address4.SetBase ("10.1.4.0", "255.255.255.0");
 
-      Ipv4InterfaceContainer interfaces12 = address1.Assign (devices12);
-      Ipv4InterfaceContainer interfaces23 = address2.Assign (devices23);
-      Ipv4InterfaceContainer interfaces34 = address3.Assign (devices34);
-      Ipv4InterfaceContainer interfaces13 = address4.Assign (devices13);
+      Ipv4InterfaceContainer interfaces01 = address1.Assign (devices01);
+      Ipv4InterfaceContainer interfaces12 = address2.Assign (devices12);
+      Ipv4InterfaceContainer interfaces23 = address3.Assign (devices23);
+      Ipv4InterfaceContainer interfaces02 = address4.Assign (devices02);
 
-      udpServerAddress = interfaces34.GetAddress (1);
+      udpServerAddress = interfaces23.GetAddress (1);
 
       // Trace routing paths for different source and destinations.
       Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> ("nix-simple-ipv4.routes", std::ios::out);
-      nixRouting.PrintRoutingPathAt (Seconds (3), nodes12.Get (0), interfaces34.GetAddress (1), routingStream);
-      nixRouting.PrintRoutingPathAt (Seconds (5), nodes12.Get (1), interfaces34.GetAddress (1), routingStream);
-      nixRouting.PrintRoutingPathAt (Seconds (6), nodes23.Get (1), interfaces12.GetAddress (0), routingStream);
-      nixRouting.PrintRoutingPathAt (Seconds (7), nodes12.Get (1), interfaces12.GetAddress (1), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (3), nodes.Get (0), interfaces23.GetAddress (1), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (5), nodes.Get (1), interfaces23.GetAddress (1), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (6), nodes.Get (2), interfaces01.GetAddress (0), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (7), nodes.Get (1), interfaces01.GetAddress (1), routingStream);
       // Trace routing tables
       nixRouting.PrintRoutingTableAllAt (Seconds (8), routingStream);
     }
@@ -277,7 +253,7 @@
       Ipv6NixVectorHelper nixRouting;
       InternetStackHelper stack;
       stack.SetRoutingHelper (nixRouting); // has effect on the next Install ()
-      stack.Install (allNodes);
+      stack.Install (nodes);
 
       Ipv6AddressHelper address1;
       address1.SetBase (Ipv6Address ("2001:1::"), Ipv6Prefix (64));
@@ -288,26 +264,26 @@
       Ipv6AddressHelper address4;
       address4.SetBase (Ipv6Address ("2001:4::"), Ipv6Prefix (64));
 
-      Ipv6InterfaceContainer interfaces12 = address1.Assign (devices12);
-      Ipv6InterfaceContainer interfaces23 = address2.Assign (devices23);
-      Ipv6InterfaceContainer interfaces34 = address3.Assign (devices34);
-      Ipv6InterfaceContainer interfaces13 = address4.Assign (devices13);
+      Ipv6InterfaceContainer interfaces01 = address1.Assign (devices01);
+      Ipv6InterfaceContainer interfaces12 = address2.Assign (devices12);
+      Ipv6InterfaceContainer interfaces23 = address3.Assign (devices23);
+      Ipv6InterfaceContainer interfaces02 = address4.Assign (devices02);
 
-      udpServerAddress = interfaces34.GetAddress (1, 1);
+      udpServerAddress = interfaces23.GetAddress (1, 1);
 
       // Trace routing paths for different source and destinations.
       Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> ("nix-simple-ipv6.routes", std::ios::out);
-      nixRouting.PrintRoutingPathAt (Seconds (3), nodes12.Get (0), interfaces34.GetAddress (1, 1), routingStream);
-      nixRouting.PrintRoutingPathAt (Seconds (5), nodes12.Get (1), interfaces34.GetAddress (1, 1), routingStream);
-      nixRouting.PrintRoutingPathAt (Seconds (6), nodes23.Get (1), interfaces12.GetAddress (0, 1), routingStream);
-      nixRouting.PrintRoutingPathAt (Seconds (7), nodes12.Get (1), interfaces12.GetAddress (1, 1), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (3), nodes.Get (0), interfaces23.GetAddress (1, 1), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (5), nodes.Get (1), interfaces23.GetAddress (1, 1), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (6), nodes.Get (2), interfaces01.GetAddress (0, 1), routingStream);
+      nixRouting.PrintRoutingPathAt (Seconds (7), nodes.Get (1), interfaces01.GetAddress (1, 1), routingStream);
       // Trace routing tables
       nixRouting.PrintRoutingTableAllAt (Seconds (8), routingStream);
     }
   
   UdpEchoServerHelper echoServer (9);
 
-  ApplicationContainer serverApps = echoServer.Install (nodes34.Get (1));
+  ApplicationContainer serverApps = echoServer.Install (nodes.Get (3));
   serverApps.Start (Seconds (1.0));
   serverApps.Stop (Seconds (10.0));
 
@@ -316,7 +292,7 @@
   echoClient.SetAttribute ("Interval", TimeValue (Seconds (1.)));
   echoClient.SetAttribute ("PacketSize", UintegerValue (1024));
 
-  ApplicationContainer clientApps = echoClient.Install (nodes12.Get (0));
+  ApplicationContainer clientApps = echoClient.Install (nodes.Get (0));
   clientApps.Start (Seconds (2.0));
   clientApps.Stop (Seconds (10.0));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/examples/nix-simple-multi-address.cc ns-3.36/src/nix-vector-routing/examples/nix-simple-multi-address.cc
--- ns-3.35/src/nix-vector-routing/examples/nix-simple-multi-address.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/examples/nix-simple-multi-address.cc	2022-04-30 18:23:58.114734600 -0700
@@ -53,7 +53,6 @@
     n2 (left)  IP: 10.1.2.2
     n2 (right) IP: 10.1.3.1, 10.2.3.1
     n3 (left)  IP: 10.1.3.2, 10.2.3.2
-
    \endverbatim
  *
  * Cases considered:
@@ -63,76 +62,77 @@
  *  - At t = +3s, Path from n0 to n1 (10.2.1.2).
  *  - At t = +7s, Path from n0 to n3 (10.2.3.2).
  *
+ * Logging output:
  * \verbatim
-   Logging output:
    At time +2s client sent 1024 bytes to 10.1.3.2 port 9
    At time +2.01106s server received 1024 bytes from 10.1.1.1 port 49153
    At time +2.01106s server sent 1024 bytes to 10.1.1.1 port 49153
    At time +2.02212s client received 1024 bytes from 10.1.3.2 port 9
-
-   Output in nix-simple-multi-address.routes:
-   Time: +3s, Nix Routing
-   Route Path: (Node 0 to Node 1, Nix Vector: 0)
-   10.2.1.1 (Node 0)   ---->   10.2.1.2 (Node 1)
-
-   Node: 0, Time: +4s, Local time: +4s, Nix Routing
-   NixCache:
-   Destination     NixVector
-   10.1.3.2        011
-   10.2.1.2        0
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.3.2        10.1.1.2        10.1.1.1          1
-
-   Node: 1, Time: +4s, Local time: +4s, Nix Routing
-   NixCache:
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.1.1        10.1.1.1        10.1.1.2          1
-   10.1.3.2        10.1.2.2        10.1.2.1          2
-
-   Node: 2, Time: +4s, Local time: +4s, Nix Routing
-   NixCache:
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.1.1        10.1.2.1        10.1.2.2          1
-   10.1.3.2        10.1.3.2        10.1.3.1          2
-
-   Node: 3, Time: +4s, Local time: +4s, Nix Routing
-   NixCache:
-   Destination     NixVector
-   10.1.1.1        000
-   Ipv4RouteCache:
-   Destination     Gateway         Source            OutputDevice
-   10.1.1.1        10.1.3.1        10.1.3.2          1
-
-   Node: 0, Time: +6s, Local time: +6s, Nix Routing
-   NixCache:
-   Ipv4RouteCache:
-
-   Node: 1, Time: +6s, Local time: +6s, Nix Routing
-   NixCache:
-   Ipv4RouteCache:
-
-   Node: 2, Time: +6s, Local time: +6s, Nix Routing
-   NixCache:
-   Ipv4RouteCache:
-
-   Node: 3, Time: +6s, Local time: +6s, Nix Routing
-   NixCache:
-   Ipv4RouteCache:
-
-   Time: +7s, Nix Routing
-   Route Path: (Node 0 to Node 3, Nix Vector: 011)
-   10.1.1.1 (Node 0)   ---->   10.1.1.2 (Node 1)
-   10.1.2.1 (Node 1)   ---->   10.1.2.2 (Node 2)
-   10.1.3.1 (Node 2)   ---->   10.2.3.2 (Node 3)
- * \endverbatim
+  \endverbatim
+ *
+ * Output in nix-simple-multi-address.routes:
+ * \verbatim
+  Time: +3s, Nix Routing
+  Route path from Node 0 to Node 1, Nix Vector: 0 (1 bits left)
+  10.2.1.1                 (Node 0)  ---->   10.2.1.2                 (Node 1)
+
+  Node: 0, Time: +4s, Local time: +4s, Nix Routing
+  NixCache:
+  Destination                   NixVector
+  10.1.3.2                      011 (3 bits left)
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  10.1.3.2                      10.1.1.2                      10.1.1.1                        1
+
+  Node: 1, Time: +4s, Local time: +4s, Nix Routing
+  NixCache:
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  10.1.1.1                      10.1.1.1                      10.1.1.2                        1
+  10.1.3.2                      10.1.2.2                      10.1.2.1                        2
+
+  Node: 2, Time: +4s, Local time: +4s, Nix Routing
+  NixCache:
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  10.1.1.1                      10.1.2.1                      10.1.2.2                        1
+  10.1.3.2                      10.1.3.2                      10.1.3.1                        2
+
+  Node: 3, Time: +4s, Local time: +4s, Nix Routing
+  NixCache:
+  Destination                   NixVector
+  10.1.1.1                      000 (3 bits left)
+  IpRouteCache:
+  Destination                   Gateway                       Source                        OutputDevice
+  10.1.1.1                      10.1.3.1                      10.1.3.2                        1
+
+  Node: 0, Time: +6s, Local time: +6s, Nix Routing
+  NixCache:
+  IpRouteCache:
+
+  Node: 1, Time: +6s, Local time: +6s, Nix Routing
+  NixCache:
+  IpRouteCache:
+
+  Node: 2, Time: +6s, Local time: +6s, Nix Routing
+  NixCache:
+  IpRouteCache:
+
+  Node: 3, Time: +6s, Local time: +6s, Nix Routing
+  NixCache:
+  IpRouteCache:
+
+  Time: +7s, Nix Routing
+  Route path from Node 0 to Node 3, Nix Vector: 011 (3 bits left)
+  10.1.1.1                 (Node 0)  ---->   10.1.1.2                 (Node 1)
+  10.1.2.1                 (Node 1)  ---->   10.1.2.2                 (Node 2)
+  10.1.3.1                 (Node 2)  ---->   10.2.3.2                 (Node 3)
+ \endverbatim
  */
 
 using namespace ns3;
 
-NS_LOG_COMPONENT_DEFINE ("NixSimpleExample");
+NS_LOG_COMPONENT_DEFINE ("NixSimpleMultiAddressExample");
 
 int
 main (int argc, char *argv[])
